package cn.com.tenlion.systembase.service.homicidepatrol;

import cn.com.tenlion.systembase.pojo.bos.homicidepatrol.HomicidePatrolBO;
import cn.com.tenlion.systembase.pojo.dtos.homicidepatrol.HomicidePatrolDTO;
import cn.com.tenlion.systembase.pojo.pos.homicidepatrol.HomicidePatrolPO;
import cn.com.tenlion.systembase.pojo.vos.homicidepatrol.HomicidePatrolVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IHomicidePatrolService
 * @Description: 命案发生地巡查记录
 * @Author: CodeFactory
 * @Date: 2021-10-20 10:44:13
 * @Version: 3.0
 **/
public interface IHomicidePatrolService {

    /**
     * 新增命案发生地巡查记录
     *
     * @param homicidePatrolVO
     * @return
     */
    void save(HomicidePatrolVO homicidePatrolVO);

    /**
     * 新增命案发生地巡查记录
     *
     * @param token
     * @param homicidePatrolVO
     * @return
     */
    void save(String token, HomicidePatrolVO homicidePatrolVO);

    /**
     * 新增命案发生地巡查记录
     *
     * @param homicidePatrolVO
     * @return homicidePatrolId
     */
    String saveReturnId(HomicidePatrolVO homicidePatrolVO);

    /**
     * 新增命案发生地巡查记录
     *
     * @param token
     * @param homicidePatrolVO
     * @return homicidePatrolId
     */
    String saveReturnId(String token, HomicidePatrolVO homicidePatrolVO);

    /**
     * 删除命案发生地巡查记录
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除命案发生地巡查记录
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除命案发生地巡查记录（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改命案发生地巡查记录
     *
     * @param homicidePatrolId
     * @param homicidePatrolVO
     * @return
     */
    void update(String homicidePatrolId, HomicidePatrolVO homicidePatrolVO);

    /**
     * 修改命案发生地巡查记录
     *
     * @param token
     * @param homicidePatrolId
     * @param homicidePatrolVO
     * @return
     */
    void update(String token, String homicidePatrolId, HomicidePatrolVO homicidePatrolVO);

    /**
     * 命案发生地巡查记录详情
     *
     * @param params 参数Map
     * @return
     */
    HomicidePatrolDTO get(Map<String, Object> params);

    /**
     * 命案发生地巡查记录详情
     *
     * @param homicidePatrolId
     * @return
     */
    HomicidePatrolDTO get(String homicidePatrolId);

    /**
     * 命案发生地巡查记录详情
     *
     * @param params 参数Map
     * @return
     */
    HomicidePatrolBO getBO(Map<String, Object> params);

    /**
     * 命案发生地巡查记录详情
     *
     * @param homicidePatrolId
     * @return
     */
    HomicidePatrolBO getBO(String homicidePatrolId);

    /**
     * 命案发生地巡查记录详情
     *
     * @param params 参数Map
     * @return
     */
    HomicidePatrolPO getPO(Map<String, Object> params);

    /**
     * 命案发生地巡查记录详情
     *
     * @param homicidePatrolId
     * @return
     */
    HomicidePatrolPO getPO(String homicidePatrolId);

    /**
     * 命案发生地巡查记录列表
     *
     * @param params
     * @return
     */
    List<HomicidePatrolDTO> list(Map<String, Object> params);

    /**
     * 命案发生地巡查记录列表
     *
     * @param params
     * @return
     */
    List<HomicidePatrolBO> listBO(Map<String, Object> params);

    /**
     * 命案发生地巡查记录列表
     *
     * @param params
     * @return
     */
    List<HomicidePatrolPO> listPO(Map<String, Object> params);

    /**
     * 命案发生地巡查记录分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<HomicidePatrolDTO>> listPage(ListPage page);

    /**
     * 命案发生地巡查记录统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}